Slope Multi Group in JavaScript

Using ApexCharts with JavaScript

This Slope Multi Group example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'North',
      data: [
        {
          x: 'Q1',
          y: 503,
        },
        {
          x: 'Q2',
          y: 580,
        },
        {
          x: 'Q3',
          y: 135,
        },
      ],
    },
    {
      name: 'South',
      data: [
        {
          x: 'Q1',
          y: 733,
        },
        {
          x: 'Q2',
          y: 385,
        },
        {
          x: 'Q3',
          y: 715,
        },
      ],
    },
    {
      name: 'East',
      data: [
        {
          x: 'Q1',
          y: 255,
        },
        {
          x: 'Q2',
          y: 211,
        },
        {
          x: 'Q3',
          y: 441,
        },
      ],
    },
    {
      name: 'West',
      data: [
        {
          x: 'Q1',
          y: 428,
        },
        {
          x: 'Q2',
          y: 749,
        },
        {
          x: 'Q3',
          y: 559,
        },
      ],
    },
  ],
  chart: {
    height: 350,
    width: 600,
    type: 'line',
  },
  plotOptions: {
    line: {
      isSlopeChart: true,
    },
  },
  title: {
    text: 'Regional Sales Rank by Quarter',
  },
  tooltip: {
    followCursor: true,
    intersect: false,
    shared: true,
  },
  dataLabels: {
    background: {
      enabled: true,
    },
    formatter(val, opts) {
      const seriesName = opts.w.config.series[opts.seriesIndex].name
      return val !== null ? seriesName : ''
    },
  },
  yaxis: {
    show: true,
    labels: {
      show: true,
    },
  },
  xaxis: {
    position: 'bottom',
  },
  legend: {
    show: true,
    position: 'top',
    horizontalAlign: 'left',
  },
  stroke: {
    width: [2, 3, 4, 2],
    dashArray: [0, 0, 5, 2],
    curve: 'smooth',
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Slope Multi Group in React

Using ApexCharts with React

This Slope Multi Group example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'North',
        data: [
          {
            x: 'Q1',
            y: 503,
          },
          {
            x: 'Q2',
            y: 580,
          },
          {
            x: 'Q3',
            y: 135,
          },
        ],
      },
      {
        name: 'South',
        data: [
          {
            x: 'Q1',
            y: 733,
          },
          {
            x: 'Q2',
            y: 385,
          },
          {
            x: 'Q3',
            y: 715,
          },
        ],
      },
      {
        name: 'East',
        data: [
          {
            x: 'Q1',
            y: 255,
          },
          {
            x: 'Q2',
            y: 211,
          },
          {
            x: 'Q3',
            y: 441,
          },
        ],
      },
      {
        name: 'West',
        data: [
          {
            x: 'Q1',
            y: 428,
          },
          {
            x: 'Q2',
            y: 749,
          },
          {
            x: 'Q3',
            y: 559,
          },
        ],
      },
    ],
    options: {
      chart: {
        height: 350,
        width: 600,
        type: 'line',
      },
      plotOptions: {
        line: {
          isSlopeChart: true,
        },
      },
      title: {
        text: 'Regional Sales Rank by Quarter',
      },
      tooltip: {
        followCursor: true,
        intersect: false,
        shared: true,
      },
      dataLabels: {
        background: {
          enabled: true,
        },
        formatter(val, opts) {
          const seriesName = opts.w.config.series[opts.seriesIndex].name
          return val !== null ? seriesName : ''
        },
      },
      yaxis: {
        show: true,
        labels: {
          show: true,
        },
      },
      xaxis: {
        position: 'bottom',
      },
      legend: {
        show: true,
        position: 'top',
        horizontalAlign: 'left',
      },
      stroke: {
        width: [2, 3, 4, 2],
        dashArray: [0, 0, 5, 2],
        curve: 'smooth',
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="line"
          height={350}
          width={600}
        />
      </div>
    </div>
  )
}

export default ApexChart

Slope Multi Group in Angular

Using ApexCharts with Angular

This Slope Multi Group example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'North',
              data: [
                {
                  x: 'Q1',
                  y: 503,
                },
                {
                  x: 'Q2',
                  y: 580,
                },
                {
                  x: 'Q3',
                  y: 135,
                },
              ],
            },
            {
              name: 'South',
              data: [
                {
                  x: 'Q1',
                  y: 733,
                },
                {
                  x: 'Q2',
                  y: 385,
                },
                {
                  x: 'Q3',
                  y: 715,
                },
              ],
            },
            {
              name: 'East',
              data: [
                {
                  x: 'Q1',
                  y: 255,
                },
                {
                  x: 'Q2',
                  y: 211,
                },
                {
                  x: 'Q3',
                  y: 441,
                },
              ],
            },
            {
              name: 'West',
              data: [
                {
                  x: 'Q1',
                  y: 428,
                },
                {
                  x: 'Q2',
                  y: 749,
                },
                {
                  x: 'Q3',
                  y: 559,
                },
              ],
            },
          ],
          chart: {
            height: 350,
            width: 600,
            type: 'line',
          },
          plotOptions: {
            line: {
              isSlopeChart: true,
            },
          },
          title: {
            text: 'Regional Sales Rank by Quarter',
          },
          tooltip: {
            followCursor: true,
            intersect: false,
            shared: true,
          },
          dataLabels: {
            background: {
              enabled: true,
            },
            formatter(val, opts) {
              const seriesName = opts.w.config.series[opts.seriesIndex].name
              return val !== null ? seriesName : ''
            },
          },
          yaxis: {
            show: true,
            labels: {
              show: true,
            },
          },
          xaxis: {
            position: 'bottom',
          },
          legend: {
            show: true,
            position: 'top',
            horizontalAlign: 'left',
          },
          stroke: {
            width: [2, 3, 4, 2],
            dashArray: [0, 0, 5, 2],
            curve: 'smooth',
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Slope Multi Group in Vue

Using ApexCharts with Vue

This Slope Multi Group example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="line"
        height="350"
        width="600"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'North',
          data: [
            {
              x: 'Q1',
              y: 503,
            },
            {
              x: 'Q2',
              y: 580,
            },
            {
              x: 'Q3',
              y: 135,
            },
          ],
        },
        {
          name: 'South',
          data: [
            {
              x: 'Q1',
              y: 733,
            },
            {
              x: 'Q2',
              y: 385,
            },
            {
              x: 'Q3',
              y: 715,
            },
          ],
        },
        {
          name: 'East',
          data: [
            {
              x: 'Q1',
              y: 255,
            },
            {
              x: 'Q2',
              y: 211,
            },
            {
              x: 'Q3',
              y: 441,
            },
          ],
        },
        {
          name: 'West',
          data: [
            {
              x: 'Q1',
              y: 428,
            },
            {
              x: 'Q2',
              y: 749,
            },
            {
              x: 'Q3',
              y: 559,
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          height: 350,
          width: 600,
          type: 'line',
        },
        plotOptions: {
          line: {
            isSlopeChart: true,
          },
        },
        title: {
          text: 'Regional Sales Rank by Quarter',
        },
        tooltip: {
          followCursor: true,
          intersect: false,
          shared: true,
        },
        dataLabels: {
          background: {
            enabled: true,
          },
          formatter(val, opts) {
            const seriesName = opts.w.config.series[opts.seriesIndex].name
            return val !== null ? seriesName : ''
          },
        },
        yaxis: {
          show: true,
          labels: {
            show: true,
          },
        },
        xaxis: {
          position: 'bottom',
        },
        legend: {
          show: true,
          position: 'top',
          horizontalAlign: 'left',
        },
        stroke: {
          width: [2, 3, 4, 2],
          dashArray: [0, 0, 5, 2],
          curve: 'smooth',
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>